OpenTTD Source: ObjectResolverObject Struct Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Data Fields | Private Member Functions
ObjectResolverObject Struct Reference

A resolver object to be used with feature 0F spritegroups. More...

`#include <newgrf_object.h>`

Inheritance diagram for ObjectResolverObject:

## Public Member Functions
| ObjectResolverObject (const ObjectSpec *spec, Object *o, TileIndex tile, uint8_t view=0, CallbackID callback=CBID_NO_CALLBACK, uint32_t param1=0, uint32_t param2=0)
| Constructor of the object resolver.
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, uint8_t relative=0) override
| Get a resolver for the scope.
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for.
uint32_t | GetDebugID () const override
| Get an identifier for the item being resolved.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor.
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup.
uint16_t | ResolveCallback ()
| Resolve callback.
virtual const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const
| Get the real sprites of the grf.
uint32_t | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.
void | ResetState ()
| Resets the dynamic state of the resolver object.

## Data Fields
ObjectScopeResolver | object_scope
| The object scope resolver.
std::optional< TownScopeResolver > | town_scope = std::nullopt
| The town scope resolver (created on the first call).
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32_t | callback_param1
| First parameter (var 10) of the callback.
uint32_t | callback_param2
| Second parameter (var 18) of the callback.
uint32_t | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32_t | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32_t | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Private Member Functions
TownScopeResolver * | GetTown ()
| Get the town resolver scope that belongs to this object resolver.

## Detailed Description

A resolver object to be used with feature 0F spritegroups.

Definition at line 133 of file newgrf_object.h.

## Constructor & Destructor Documentation

## ◆ ObjectResolverObject()

ObjectResolverObject::ObjectResolverObject | ( | const ObjectSpec * | spec,
|  | Object * | obj,
|  | TileIndex | tile,
|  | uint8_t | view = `0`,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32_t | param1 = `0`,
|  | uint32_t | param2 = `0`
| ) |  |

Constructor of the object resolver.

Parameters

  obj | Object being resolved.
  tile | Tile of the object.
  view | View of the object.
  callback | Callback ID.
  param1 | First parameter (var 10) of the callback.
  param2 | Second parameter (var 18) of the callback.

Definition at line 377 of file newgrf_object.cpp.

References ObjectSpec::grf_prop, ResolverObject::root_spritegroup, and GRFFilePropsBase< Tcnt >::spritegroup.

## Member Function Documentation

## ◆ GetDebugID()

uint32_t ObjectResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 410 of file newgrf_object.cpp.

References ObjectSpec::grf_prop, GRFFilePropsBase< Tcnt >::local_id, object_scope, and ObjectScopeResolver::spec.

## ◆ GetFeature()

GrfSpecFeature ObjectResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 405 of file newgrf_object.cpp.

## ◆ GetScope()

ScopeResolver * ObjectResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | uint8_t | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 140 of file newgrf_object.h.

References ResolverObject::GetScope(), GetTown(), object_scope, VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

Referenced by NIHObject::Resolve().

## ◆ GetTown()

TownScopeResolver * ObjectResolverObject::GetTown | ( |  | ) |
| private

Get the town resolver scope that belongs to this object resolver.

On the first call, the town scope is created (if possible).

Returns
  Town scope, if available.

Definition at line 390 of file newgrf_object.cpp.

References ClosestTownFromTile(), ObjectScopeResolver::obj, object_scope, ObjectScopeResolver::tile, Object::town, and town_scope.

Referenced by GetScope().

## Field Documentation

## ◆ object_scope

ObjectScopeResolver ObjectResolverObject::object_scope

The object scope resolver.

Definition at line 134 of file newgrf_object.h.

Referenced by GetDebugID(), GetScope(), and GetTown().

## ◆ town_scope

std::optional<TownScopeResolver> ObjectResolverObject::town_scope = std::nullopt

The town scope resolver (created on the first call).

Definition at line 135 of file newgrf_object.h.

Referenced by GetTown().

The documentation for this struct was generated from the following files:

- src/newgrf_object.h
- src/newgrf_object.cpp